# "JumpingPrison" Core Wars program
# Version 1.0.0
#
# Eric Burton, 2000-10-05
#
# Okay, this looks strange...
# The point is this: since it
# only sweeps ever other row,
# the redundancy in the moved
# code stops it from killing
# itself -- as well as just making
# it harder to crash.
#
# In normal course, this program's sweeping
# will run quite happily through the sweeper
# code and not change a damn thing.  :)
#
# Depending on where the opponents' code loads,
# this can make for some games that are
# interesting to watch if nothing else. ;)  Many
# times the fact that the code being copied is
# a jump into the sweeper routine will result
# in inadvertant vampirism... hence the "Prison"
# in the title.  This will cause many programs
# to bounce between one of their original instructions
# and one of the copied jumps indefinitely.
#
# Weakness: Warriors that smash offset 809. ;) I
#           suppose I could make it a more random
#           number, or perhaps not use a loader
#           at all, but this way I know for certain
#           which bytes get smashed.  The next version
#           should have more effective redundancy
#           and no loader.
#

        title "JumpingPrison"
        author "Eric Burton <mistersnee@usa.net>"
        
OFFSET: data 0
DOFFSET:data 809 # Arbitrary number :)
JUMPTO: data 809
COUNTER:data 9
        move &A, OFFSET
mvloop: movei OFFSET, DOFFSET
        loop COUNTER, mvloop
        jump [JUMPTO]
        
A:      move B, [I]
B:      add 2, I
C:      jump A
D:      move C, [H]
E:      add 2, H
F:      jump C
G:      jump A
H:      data 0
I:      data 0
