# RollingStones, version 2.2
# Jules Agee, April 2000

# This warrior is an attempt to add some resilience to my original 
# "RollingStones" warrior. The original is very effective in one-on-one
# games, but dies quickly in all-against-all games. Unfortunately, because
# of the size added to the program, in most matches it becomes very
# vulnerable to fork-bomb type attacks, so I don't think it will do
# much better than the original in all-against-all games.

# However, it does well against warriors without fork-bomb attacks. It
# starts three instances of itself, spaced evenly through core. Then it drops
# forkbombs in a mod-5 pattern through core until it detects that it has a 
# number of processes not equal to three. At that moment, each process scans 
# the location where the next higher process should be. If it detects any
# alien code, it zeroes the area and copies itself there. 

title "RollingStones 2.2"
author "Jules Agee <jag@seanet.NoSpamPlease.com>"

EnterStageLeft:	info 0, WheresMick	#WheresMick stores the location of 
Setup:		div 3, WheresMick	  #the next process in memory
Lightshow:	info 4, Players		#Players is the number of processes
		equal Players, 3	#If there are three, start bombing
		jump nJackFlash

		move &Lightshow, Here	#This section creates a new instance
		move &Lightshow, There	  #of the warrior. 
		add WheresMick, There
		move 49, Tunes		#Tunes is the length of the program
Dance:		movei Here, There	#This is the part which actually copies
		loop Tunes, Dance	  #the code from here to there.
		add -8, There		
		add WheresMick, [There]	#Adds WheresMick to the address where
		add -41, There		  #the new process starts bombing, so
		fork [There]		  #they're not all nuking the same spot


#This section is mostly taken from the original RollingStones program.

nJackFlash:	add -95, itsaGas	#itsaGas is the bombing target
		equal [itsaGas], 0	#No sense bombing it if nothing's there
		jump nJackFlash
		own [itsaGas]		#Especially bad to bomb it if its part
		jump nJackFlash		  #of this program.    :)
		move you, [itsaGas]
		add 1, itsaGas
		move yeah, [itsaGas]
		add -1, itsaGas		#moves the pointer back to preserve the
		info 4, Players		  #mod-5 bombing pattern
		equal Players, 3	#checks again for number of processes
		jump nJackFlash

#In this section, "Players" is re-used as a pointer to the location being
#scanned for data integrity, "Here" is re-used as a pointer to the beginning of
#the next process' code, and "There" is re-used as a pointer to the end of its 
#code.

		move &Setup, Players	#This part just sets up the pointers.
		add WheresMick, Players
		move &Lightshow, Here
		move &yeah, There
		add WheresMick, Here
		add WheresMick, There
Cardgame:	add 1, Players
		equal Players, There	#if we've scanned the entire area with
		jump nJackFlash		  #no problems, go back to bombing.
		own [Players]		#if alien code is found, it skips to
		jump Cardgame		  #the PARTY section.
		move 49, Tunes
PARTY:		move Players, [Here]	#This section deletes the area we just
		add 1, Here		  #scanned, then jumps to the start,
		loop Tunes, PARTY	  #which will copy itself over to the
		jump Lightshow		  #deleted area and start it again.
itsaGas:	data &EnterStageLeft
Players:	data 0
Tunes:		data 0
Here:		data 0
There:		data 0
WheresMick:	data 0
you:		fork you		# This is the bomb.
yeah:		jump you
