# Core Wars program
#
# Paul Dann (Compuboy)
#
# July 2001

	title "Mostly Harmless"
        author "Paul Dann <Compuboy1521@Yahoo.com>"

# This program will maintain at least 4 threads at all times as well as seaking
# non-zero memory addresses that are not owned by the process and overwriting
# them backwards with Loop Bombs until blank memory is encountered. In most cases,
# if the target was an enemy thread, this will cause it to jump to the same memory
# location, causing the thread to 'freeze' for a period of time. I decided to use
# an L Bomb instead of an D Bomb (Data Bomb) because D Bombs will cause enemy
# threads to die instantly. This may sound good but quite often, programs have
# spawnable threads. This means that when a thread dies, it will be replaced.
# However, an L Bomb does not cause the thread to die, meaning that no new thread
# will be spawned. I also considered using F Bombs (Fork Bombs) but I believe F
# Bombs to be 'unethical'. F bombs cause enemy threads to fork uncontrolably,
# causing a thread limit violation. This means that the game is forfeit and not
# won. I consider a game lost to a F Bomb to be at most a draw. L Bombs do not
# cause forking and mearly stop the execution of threads without killing them.
# I originaly used a 'jump JBOMB' command but I found that this made it impossible
# to kill the enemy thread and the game would end in a draw. I discovered the L
# Bomb by mistake and I am still not sure why it works!

# I have included command descriptions for those who want to understand the programming
# I have used. I would apreciate any information reguarding programs that can consistantly
# beat 'Mostly Harmless' or any other comments. My E-Mail address is included at the top
# of the program. Have fun!

A:	data 0			#Storage location
B:	data 0			#Storage location
C:	data 0			#Storage location
D:	data 0			#Storage location

MAIN:	info 2, A		#Assign a random memory address to A
NEXT:	info 4, B		#Assign the number of running threads to B
	less B, 4		#If B is lower than 4,
	jump BSPAWN		#Go to the section marked 'BSPAWN'
	own [A]			#If the memory address stored in A is owned by this process,
	jump MAIN		#Go to the section marked 'MAIN'
	equal 0, [A]		#If the information stored in the memory address stored in A is equal to 0,
	jump MAIN		#Go to the section marked 'MAIN'
	move LBOMB, [A]		#Copy the section marked 'JBOMB' to the memory address stored in A
	add -1, A		#Subtract 1 from A
	jump NEXT		#Go to the section marked 'NEXT'

BSPAWN:	info 2, B		#Assign a random memory address to B
	move B, D		#Copy B to D
	add 4, D		#Add 4 to D
	move &A, C		#Copy the memory address of A to C
	move 25, A		#Assign 25 to A
BSLOOP:	movei C, B		#Copy from the memory address stored in C to the memory address stored in B, add 1 to C, add 1 to B
	loop A, BSLOOP		#If A is not 0 then go to the section marked 'BSLOOP', subtract 1 from A
	fork [D]		#Start a new thread at the memory address stored in D
	jump MAIN		#Go to the section marked 'MAIN'

LBOMB:	loop A, LBOMB		#If A is not 0 then go to the section marked 'LBOMB', subtract 1 from A
